IMPLEMENTATION MODULE oopsmsg1; (* Ken Badertscher (KBAD) 2/23/87 *)

PROCEDURE AssignErr1(VAR errs : ErrMsgs);
BEGIN
errs[0] := '(* ^^^undefined error *)';
errs[10] := '(* ^^^identifier expected *)';
errs[11] := '(* ^^^,  comma expected *)';
errs[12] := '(* ^^^;  semicolon expected *)';
errs[13] := '(* ^^^:  colon expected *)';
errs[14] := '(* ^^^.  period expected *)';
errs[15] := '(* ^^^)  right parenthesis expected *)';
errs[16] := '(* ^^^]  right bracket expected *)';
errs[17] := '(* ^^^}  right brace expected *)';
errs[18] := '(* ^^^=  equal sign expected *)';
errs[19] := '(* ^^^:=  assignment expected *)';
errs[20] := '(* ^^^END expected *)';
errs[21] := '(* ^^^..  ellipsis expected *)';
errs[22] := '(* ^^^(  left parenthesis expected *)';
errs[23] := '(* ^^^OF expected *)';
errs[24] := '(* ^^^TO expected *)';
errs[25] := '(* ^^^DO expected *)';
errs[26] := '(* ^^^UNTIL expected *)';
errs[27] := '(* ^^^THEN expected *)';
errs[28] := '(* ^^^MODULE expected *)';
errs[30] := '(* ^^^IMPORT expected *)';
errs[31] := '(* ^^^factor starts with illegal symbol *)';
errs[32] := '(* ^^^identifier, (, or [ expected *)';
errs[33] := 
  '(* ^^^identifier,ARRAY,RECORD,SET,POINTER,PROCEDURE,(,or [ expected *)';
errs[34] := '(* ^^^Type followed by illegal symbol *)';
errs[35] := '(* ^^^statement starts with illegal symbol *)';
errs[36] := '(* ^^^declaration followed by illegal symbol *)';
errs[37] := '(* ^^^statement part is not allowed in definition module *)';
errs[38] := '(* ^^^export list not allowed in program module *)';
errs[39] := '(* ^^^EXIT not inside a LOOP statement *)';
errs[40] := '(* ^^^illegal character in number *)';
errs[41] := '(* ^^^number too large *)';
errs[42] := '(* ^^^ (* comment without closing "*)" *)';
errs[50] := '(* ^^^identifier not declared or not visible *)';
errs[51] := '(* ^^^object should be a constant *)';
errs[52] := '(* ^^^object should be a type *)';
errs[53] := '(* ^^^object should be a variable *)';
errs[54] := '(* ^^^object should be a procedure *)';
errs[55] := '(* ^^^object should be a module *)';
errs[56] := '(* ^^^type should be a subrange *)';
errs[57] := '(* ^^^type should be a record *)';
errs[58] := '(* ^^^type should be an array *)';
errs[59] := '(* ^^^type should be a set *)';
errs[60] := '(* ^^^illegal base type of set *)';
errs[61] := '(* ^^^incompatible type of label or of subrange bound *)';
errs[62] := '(* ^^^multiply defined case (label) *)';
errs[63] := '(* ^^^low bound > high bound *)';
errs[64] := '(* ^^^more actual than formal parameters *)';
errs[65] := '(* ^^^fewer actual than formal parameters *)';
errs[66] := '(* ^^^more parameters in I than in D *)';

END AssignErr1;

END oopsmsg1.

